'Cyfrowy miernik czestotliwosci odswiezania ekranu
'Marcin Wiazania


Config Timer0 = Counter , Gate = Internal , Mode = 1
Config Timer1 = Timer , Gate = Internal , Mode = 1
On Timer1 Odlicz_sek

Dim Licz As Byte                                              'zmienna pomocnicza pracujaca jako licznik
Dim Mierz As Bit                                              'flaga pomocnicza dla pomiaru
Dim Zezw As Bit                                               'flaga pomocnicza procedury wyswietlacza
Dim Freq As Word                                              'zmienna przechowuje zmierzona wartosc czestotliwosci
Dim Flag1 As Bit                                              'flaga odpowiedzialna za prawidlowe multipleksowanie wyswietlacza

Enable Interrupts
Enable Timer1

Licz = 0
Mierz = 0
Set P3.3
Counter1 = 56380
Start Timer1                                                  'start czasomierza

Do
  If Zezw = 1 Then                                            'jezeli flaga zewm=1 to wykonaj dzialania na wyswietlaczu
    Flag1 = Not Flag1
    P1 = 255
    Set P3.0
    Set P3.1
    Set P3.2
    Set P3.7
    Set P3.5
    If P3.3 = 1 Then                                          'Jezeli P3.3=1 to tryb punktowy w przeciwnym razie tryb linijkowy
      If Flag1 = 1 Then                                       'jezeli flaga1=1 to zaswiec 1 sekcje diod w przeciwnym razie druga sekcje diod
        Reset P3.7
        If Freq > 58 Then                                     'jezeli zmierzona wartosc wieksza od 58 to zapal led podlaczona do p1.7
          P1 = 255
          Reset P1.7
        End If
        If Freq > 68 Then
          P1 = 255
          Reset P1.6
        End If
        If Freq > 78 Then
          P1 = 255
          Reset P1.5
        End If
        If Freq > 88 Then
          P1 = 255
          Reset P1.4
        End If
        If Freq > 98 Then
          P1 = 255
          Reset P1.3
        End If
        If Freq > 108 Then
          P1 = 255
          Reset P1.2
        End If
        If Freq > 118 Then
          P1 = 255
          Reset P1.1
        End If
        If Freq > 128 Then
          P1 = 255
          Set P3.0
          Set P3.1
          Set P3.2
          Reset P1.0
        End If
        If Freq > 138 Then
          P1 = 255
          Set P3.0
          Set P3.1
          Set P3.2
          Reset P3.0
        End If
        If Freq > 148 Then
          P1 = 255
          Set P3.0
          Set P3.1
          Set P3.2
          Reset P3.1
        End If
        If Freq > 158 Then
          Reset P3.2
          P1 = 255
          Set P3.0
          Set P3.1
          Set P3.2
          Reset P3.2
        End If
      Else                                                    'obsluga drugiej sekcji diod przy flag1=0
        Reset P3.5
        If Freq = 65 Then
          Reset P1.7
        End If
        If Freq = 75 Then
          Reset P1.6
        End If
        If Freq = 85 Then
          Reset P1.5
        End If
        If Freq = 95 Then
          Reset P1.4
        End If
        If Freq = 105 Then
          Reset P1.3
        End If
        If Freq = 115 Then
          Reset P1.2
        End If
        If Freq = 125 Then
          Reset P1.1
        End If
        If Freq = 135 Then
          Reset P1.0
        End If
        If Freq = 145 Then
          Reset P3.0
        End If
        If Freq = 155 Then
          Reset P3.1
        End If
      End If
    Else                                                      'Ponizsze instrukcje realizuja tryb linijkowy wyswietlacza
      If Flag1 = 1 Then
        Reset P3.7
        If Freq > 59 Then
          Reset P1.7
        End If
        If Freq > 69 Then
          Reset P1.6
        End If
        If Freq > 79 Then
          Reset P1.5
        End If
        If Freq > 89 Then
          Reset P1.4
        End If
        If Freq > 99 Then
          Reset P1.3
        End If
        If Freq > 109 Then
          Reset P1.2
        End If
        If Freq > 119 Then
          Reset P1.1
        End If
        If Freq > 129 Then
          Reset P1.0
        End If
        If Freq > 139 Then
          Reset P3.0
        End If
        If Freq > 149 Then
          Reset P3.1
        End If
        If Freq > 159 Then
          Reset P3.2
        End If
      Else
        Reset P3.5
        If Freq > 64 Then
          Reset P1.7
        End If
        If Freq > 74 Then
          Reset P1.6
        End If
        If Freq > 84 Then
          Reset P1.5
        End If
        If Freq > 94 Then
          Reset P1.4
        End If
        If Freq > 104 Then
          Reset P1.3
        End If
        If Freq > 114 Then
          Reset P1.2
        End If
        If Freq > 124 Then
          Reset P1.1
        End If
        If Freq > 134 Then
          Reset P1.0
        End If
        If Freq > 144 Then
          Reset P3.0
        End If
        If Freq > 154 Then
          Reset P3.1
        End If
      End If
    End If
    Zezw = 0
  End If
Loop
End

Odlicz_sek:                                                   'obsluga przerwania timera 1 pracujacego jako czasomierz
  Counter1 = 56380                                            'wartosc poczatkowa ladowana do timera 1
  Start Timer1
  Incr Licz                                                   'inkrementacja zmiennej licznikowej
  Set Zezw                                                    'zezwolenie na obsluge wyswietlacza co ok. 10ms
  If Licz = 100 Then                                          'Jezeli licz=100 to odliczona zostala 1 sekunda
    Licz = 0                                                  'zerowanie zmiennej licz
    Mierz = Not Mierz                                         'inwersja flagi mierz
    If Mierz = 1 Then                                         'jezeli flaga mierz=1 to
      Start Timer0                                            'odblokuj timer 0
    Else                                                      'w przeciwnym razie
      Stop Timer0                                             'zablokuj licznik
      Freq = Counter0                                         'przepisz zmierzona ilosc impulsow do zmiennej freq
      Counter0 = 0                                            'zeruj wartosc licznika
    End If
  End If
Return
