
$large
$baud = 9600
Config Scl = P3.7
Config Sda = P3.5
Config Lcd = 16 * 1a
Config Spi = Soft , Din = P3.3 , Dout = P3.2 , Clk = P3.4 , Nocs=

Declare Sub Klawiatura
Declare Sub W_volt
Declare Sub W_amp
Declare Sub Wys_ca
Declare Sub Volt_amp
Declare Sub Wysw
Declare Sub Pomiar
Declare Sub Oblicz
Declare Sub Pcf
Declare Sub W_eeprom(adres As Byte , Value As Byte)
Declare Sub R_eeprom(adres As Byte , Value As Byte)
Declare Sub Odczyt_st
Declare Sub Wyb_przel
Declare Sub Zap_param

Dim Key As Byte
Dim Adres As Byte
Dim Value As Byte
Dim K As Byte
Dim Temp1 As Byte
Dim Temp2 As Word
Dim Temp3 As Word
Dim Temp4 As Byte
Dim Temp5 As Byte
Dim Temp6 As Byte
Dim Temp7 As Byte
Dim I As Byte
Dim Ust(3) As Word
Dim Conf As Byte
Dim X(2) As Byte
Dim J As Byte
Dim Va As Bit
Dim Flag1 As Bit
Dim Flag2 As Bit
Dim Flag3 As Bit
Dim Nr_przyc As Byte
Dim Zm_rs As String * 1

Cursor Off
Flag1 = 0
Conf = 255
Reset Conf.1
Reset Conf.3
Reset Conf.2
Call Pcf
J = 1
Va = 0
Call R_eeprom(150 , Value)                                    'zerowanie oraz inicjalizowanie pamieci eeprom jezeli byla pusta
If Value <> 50 Then
 For I = 0 To 100
 Call W_eeprom(i , 0)
 Next I
 Call W_eeprom(150 , 50)
End If

Call Klawiatura                                               'instrukcje pobierania danych przy programowaniu zasilacza
If Key = 189 Then                                             'dla napiec i pradow przyporzadkowanych na stale
 Flag3 = 1
 Nr_przyc = 1
 Call Odczyt_st
 Temp5 = 0
 Do
  Call Klawiatura
  If Key = 237 Then
   Call Zap_param
  End If
  Call Wyb_przel
  If Nr_przyc <> Temp5 Then
   Temp5 = Nr_przyc
   Key = 125
   Call Wyb_przel
   Call Odczyt_st
   Key = 125
   Call Wyb_przel
  End If
  Call Wysw
  Waitms 150
 Loop
End If

J = 1                                                         'ustawienie w "R" stanu zasilacza po wlaczeniu
Key = 221
Call Wyb_przel
J = 2
Key = 221
Call Wyb_przel
J = 1
Flag3 = 1

Do                                                            'Program glowny ktory zawiera pozostale reakcje na nacisniety klawisz
 Call Wysw                                                    'sterowanie wentylatorem
 Call Klawiatura                                              'przekaznikiem PK1
 Zm_rs = Inkey()                                              'oraz transmisja RS232
 If Zm_rs = "p" Then
  Temp7 = Conf And &B10000000
  Rotate Temp7 , Left , 1
  Print Ust(1) ; ":" ; Ust(2) ; ":" ; Ust(3) ; ":" ; Temp7 ; ":" ; J
 End If
 If Zm_rs = "o" Then
  Key = 237
 End If
 If Zm_rs = "w" Then
  Key = 189
 End If
 If Zm_rs = "r" Then
  Key = 125
 End If
 If Zm_rs = "a" Then
  Key = 238
 End If
 If Zm_rs = "z" Then
  Key = 222
 End If
 If Zm_rs = "s" Then
  Key = 190
 End If
 If Zm_rs = "x" Then
  Key = 126
 End If
 Temp5 = Asc(zm_rs)
 Temp5 = Temp5 - 48
 If Temp5 > 0 And Temp5 < 10 Then
  Nr_przyc = Temp5
  Call Odczyt_st
 End If
 If Key = 189 Then
  Flag3 = 1
  Flag1 = Not Flag1
 End If
 If Key = 237 Then
  If Conf.7 = 1 Then
   Reset Conf.7
  Else
   Set Conf.7
  End If
  Call Pcf
 End If
 Call Wyb_przel
 K = 3
 Call Oblicz
 If P3.6 = 1 Then
  Reset Conf.1
 Else
  Set Conf.1
 End If
 Call Pcf
 Waitms 20
Loop
End

Sub Wyb_przel                                                 'Czesc procedury reakcji na nacisniety klawisz
 If Key = 119 Then
  Nr_przyc = 1
  Call Odczyt_st
 End If
 If Key = 183 Then
  Nr_przyc = 2
  Call Odczyt_st
 End If
 If Key = 215 Then
  Nr_przyc = 3
  Call Odczyt_st
 End If
 If Key = 231 Then
  Nr_przyc = 4
  Call Odczyt_st
 End If
 If Key = 123 Then
  Nr_przyc = 5
  Call Odczyt_st
 End If
 If Key = 187 Then
  Nr_przyc = 6
  Call Odczyt_st
 End If
 If Key = 219 Then
  Nr_przyc = 7
  Call Odczyt_st
 End If
 If Key = 235 Then
  Nr_przyc = 8
  Call Odczyt_st
 End If
 If Key = 221 Then
  Nr_przyc = 9
  Flag2 = 1
  Call Odczyt_st
 End If
 If Key = 190 Then
  Flag3 = 1
  Temp6 = 0
  Incr Ust(j)
  Call Volt_amp
 End If
 If Key = 126 Then
  Flag3 = 1
  Temp6 = 0
  Decr Ust(j)
  Call Volt_amp
 End If
 If Key = 238 Then
  Flag3 = 1
  Temp6 = 0
  Ust(j) = Ust(j) + 10
  Call Volt_amp
 End If
 If Key = 222 Then
  Flag3 = 1
  Temp6 = 0
  Ust(j) = Ust(j) - 10
  Call Volt_amp
 End If
 If Key = 125 Then
  Flag3 = 1
  Va = Not Va
  If Va = 0 Then
   J = 1
  Else
   J = 2
  End If
 End If
 If Ust(1) > 120 Then
  Reset Conf.0
 Else
  Set Conf.0
 End If
 Call Pcf

End Sub

Sub Odczyt_st                                                 'Oczyt ustawien z eeprom
 Flag3 = 1
 Adres = Nr_przyc * 10
 If J = 2 Then
  Adres = Adres + 5
 Else
  Flag2 = 0
  Set Conf.7
  Call Pcf
 End If
 Call R_eeprom(adres , Value)
 Temp4 = Value
 Incr Adres
 Call R_eeprom(adres , Value)
 Ust(j) = Makeint(temp4 , Value)
 Call Volt_amp
End Sub

Sub Pcf
 I2csend 112 , Conf
End Sub

Sub Klawiatura                                                'Obsluga klawiatury
 For I = 0 To 3
  Temp1 = 255
  Reset Temp1.i
  I2csend 124 , Temp1
  I2creceive 125 , Key
  If Key = 254 Or Key = 253 Or Key = 251 Or Key = 247 Then
   Key = 0
  End If
  If Key <> 0 Then
   If Key = Temp6 Then
    Key = 0
    Exit Sub
   End If
   Temp6 = Key
   Exit Sub
  End If
 Next I
 Temp6 = 0
End Sub

Sub W_volt                                                    'Zakres ustawien napiecia
 If Ust(1) < 30 Then
  Ust(1) = 30
 End If
 If Ust(1) > 240 Then
  Ust(1) = 240
 End If
 I = 5
 Temp2 = Ust(1) * 10
 Temp2 = Temp2 / 3
 Call Wys_ca
End Sub

Sub W_amp                                                     'Zakres ustawien pradu
 If Ust(2) = 0 Or Ust(2) > 1000 Then
  Ust(2) = 1
 End If
 If Ust(2) > 400 Then
  Ust(2) = 400
 End If
 I = 6
 Temp2 = Ust(2) * 10
 Temp2 = Temp2 / 5
 Call Wys_ca
End Sub

Sub Wys_ca                                                    ' Wyslanie danych do przetwornikow C/A
 Temp1 = Temp2 Mod 128
 Temp2 = Temp2 - Temp1
 Temp2 = Temp2 / 128
 Reset Conf.i
 Call Pcf
 X(1) = Temp2
 X(2) = Temp1 * 2
 Spiout X(1) , 2
 Set Conf.i
 Call Pcf
End Sub

Sub Volt_amp                                                  'sterowanie zapisem wartosci U oraz I
 If J = 1 Then
  Call W_volt
 Else
  Call W_amp
 End If
 If Flag2 = 1 Then
  Nr_przyc = 9
 End If
 If Nr_przyc = 9 Then
  Call Zap_param
 End If
End Sub

Sub Zap_param                                                 'Zapis ustawien do eeprom
 Adres = Nr_przyc * 10
 If J = 2 Then
  Adres = Adres + 5
 End If
 Value = Low(ust(j))
 Call W_eeprom(adres , Value)
 Value = High(ust(j))
 Incr Adres
 Call W_eeprom(adres , Value)
End Sub

Sub Pomiar                                                    'odczyt zmierzonej watrosci z przetwornika
 Ust(3) = 0
 For I = 1 To 2
  Waitms 50
  Temp1 = 0
  Temp2 = 0
  Reset Conf.4
  Call Pcf
  Spiin X(1) , 2
  Set Conf.4
  Call Pcf
  Temp2 = X(1) - 128
  Temp2 = Temp2 * 8
  Temp1 = X(2) And &B11111000
  Temp1 = Temp1 / 32
  Temp2 = Temp2 + Temp1
  Ust(3) = Ust(3) + Temp2
 Next I
 Ust(3) = Ust(3) / 2
End Sub

Sub Oblicz                                                    'sterowanie dzielnikiem pomiarowym
 Reset Conf.3 : Reset Conf.2
 Call Pcf
 Call Pomiar
 If Ust(3) > 1000 Then
  Set Conf.3
  Call Pcf
  Call Pomiar
  If Ust(3) > 1000 Then
   Reset Conf.3
   Set Conf.2
   Call Pcf
   Call Pomiar
   Ust(3) = Ust(3) * 10
  Else
   Ust(3) = Ust(3) * 1
  End If
 Else
  Ust(3) = Ust(3) / 10
 End If
End Sub

Sub Wysw                                                      'obsluga wyswietlacza lcd
 If Flag3 = 1 Or Flag1 = 1 Then
  Flag3 = 0
  Cls
  Ust(2) = Ust(2) * 10
  K = 1
  Temp1 = Ust(k) / 10
  Temp2 = Temp1 * 10
  Temp2 = Ust(k) - Temp2
  If Va = 0 And Flag1 = 0 Then
   Lcd ">"
  End If
  Lcd "U=" ; Temp1 ; "." ; Temp2 ; "V "
  If Va = 1 And Flag1 = 0 Then
   Locate 1 , 9
   Lcd ">"
  End If
 Locate 1 , 10
 If Flag1 = 1 Then
  K = K + 2
 Else
  K = K + 1
 End If
 Lcd "I=" : Lcd Ust(k)
 Lcd "mA"
 If Ust(k) => 1000 Then
  Locate 1 , 13 : Lcd Ust(k)
  Locate 1 , 13 : Lcd "."
  Locate 1 , 16 : Lcd "A"
 End If
 Ust(2) = Ust(2) / 10
 End If
End Sub

Sub W_eeprom (adres As Byte , Value As Byte)                  ' wysyla dane na i2c
   I2cstart
   I2cwbyte 160
   I2cwbyte Adres
   I2cwbyte Value
   I2cstop
   Waitms 10
End Sub

Sub R_eeprom(adres As Byte , Value As Byte)                   ' odbiera dane i2c
   I2cstart
   I2cwbyte 160
   I2cwbyte Adres
   I2cstart
   I2cwbyte 161
   I2crbyte Value , 9
   I2cstop
End Sub