'Komunikator namiotowy
'Marcin Wizania

Declare Sub Wysw_dzies
Declare Sub Sygn
Declare Sub Sygn_komunikat
Declare Sub Wysw_pob_bin
Declare Sub Led_mig

Dim Command As Byte , Subaddress As Byte
Dim Temp As Byte
Dim Temp1 As Byte
Dim Temp2 As Byte
Dim New As Bit
Dim Zezw_kom As Bit
Dim I As Byte
Dim Flaga1 As Bit
Dim J As Byte
Dim K As Byte

Reset Tcon.0
On Int0 Odb_rc5
On Int1 Skas_kom
Enable Int0
Enable Int1
Enable Interrupts
Buzzer Alias P3.5
Jp Alias P3.7
S1 Alias P3.3
Led_red Alias P3.4

P3 = 255
P1 = 255
Command = 255
Temp1 = 254
New = 0
Zezw_kom = 0
Flaga1 = 0
Reset Buzzer

Do                                                            'Petla glowna programu
   If New = 1 Then                                            'Jezeli odebrano kod rc5 wykonaj ponizsze instrukcje
      Disable Int0
      New = 0
      Temp = Command
      Enable Int0
      Set Jp
      If Jp = 0 Then                                          'Jezeli zworka jp zwarta to
         Call Wysw_dzies                                      'wywolaj "wysw_dzies" a jezeli rozwarta to
         Zezw_kom = 1                                         'wywolaj procedure "wysw_pob_bin"
      Else
         Call Wysw_pob_bin
      End If
      Call Sygn_komunikat                                     'Procedura sygnalizacji dotarcia komunikatu
   End If
   Waitms 100
   If New = 0 Then                                            'Jezeli brak transmisji to przejdz w stan IDLE
      Idle
   End If
Loop
End

Sub Led_mig                                                   'Procedura realizujaca migniecie diody LED red
   Waitms 200
   Reset Led_red
   Waitms 200
   Set Led_red
End Sub

Sub Wysw_pob_bin                                              'Procedura pobiera oraz wyswietla przeslany kod binarny
   J = 1
   I = 1
   Command = 255
   Temp1 = 255
   Zezw_kom = 0
   For I = 1 To 500
      New = 0
      Enable Int0
         If J = 1 And Command < 3 Then                        'Podranie pierwszej cyfry (setki)
            Disable Int0
            Temp = Command * 100
            Incr J
            I = 1
            Command = 255
            Call Led_mig                                      'Jedno migniecie diody red
            Waitms 500
            Temp1 = 255
         End If
         If Temp >= 200 Then                                  'Pobranie drugiej cyfry (dziesitek)
            If J = 2 And Command < 6 Then
               Disable Int0
               Temp2 = Command * 10
               Temp = Temp + Temp2
               Incr J
               Command = 255
               I = 1
               Call Led_mig                                   'dwa migniecia diody red
               Call Led_mig
               Waitms 500
               Temp1 = 255
            End If
         Else
            If J = 2 And Command < 10 Then
               Disable Int0
               Temp2 = Command * 10
               Temp = Temp + Temp2
               Incr J
               Command = 255
               I = 1
               Call Led_mig
               Call Led_mig
               Waitms 500
               Temp1 = 255
            End If
         End If
         If Temp = 250 Then                                   'Pobranie trzeciej cyfry (jednostek)
            If J = 3 And Command < 6 Then
               Disable Int0
               Temp = Temp + Command
               Incr J
               Command = 255
               I = 1
               Call Led_mig                                   'Trzy migniecia diody red
               Call Led_mig
               Call Led_mig
               Waitms 500
               Temp1 = 255
            End If
         Else
            If J = 3 And Command < 10 Then
               Disable Int0
               Temp = Temp + Command
               Incr J
               Command = 255
               I = 1
               Call Led_mig
               Call Led_mig
               Call Led_mig
               Waitms 500
               Temp1 = 255
            End If
         End If
         If Command = 12 Then                                 'Jezeli przeslany rozkaz wynosi 12 to wyjdz z procedury
            Disable Int0                                      'wprowadzania trzy cyfrowego komunikatu
            Zezw_kom = 0
            For K = 1 To 10
               Led_red = Not Led_red
               Waitms 80
            Next K
            Set Led_red
            Exit For
         End If
         If J = 4 Then                                        'Jezeli przeslano trzy liczby to wyswietla ja na wyswietlaczu
            New = 0
            If Temp <> 0 Then
               Temp = Not Temp
               P1 = Temp
               Zezw_kom = 1
            End If
            Exit For
         End If
         Waitms 10
   Next I
   New = 0
   Enable Int0
End Sub

Sub Sygn                                                      'Procedura generacji krotkiego dzwieku
   Waitms 200
   Set Buzzer
   Waitms 200
   Reset Buzzer
End Sub

Sub Sygn_komunikat                                            'Procedura sygnalizacji przeslanego komunikatu
    For I = 1 To 10
       If Zezw_kom = 0 Or New = 1 Then                        'Generuje sygnal dzwiekowy przez ok. 4 sekundy
          Exit For
       End If
       If I < 5 Then
          Led_red = Not Led_red
       Else
          Set Led_red                                         'Powiadamia o dotarciu komunikatu
       End If
       Call Sygn
    Next I
    For I = 1 To 100                                          'Wyswietla przeslany komunikat przez ok. 10 sekund
       Waitms 100
       If Zezw_kom = 0 Or New = 1 Then
          Exit For
       End If
    Next I
    P1 = 255
    Set P3.0
    Set P3.1
End Sub

Sub Wysw_dzies                                                'Wyswietla przeslany komunikat przy pracy w trybie dziesietnym
  P1 = 255
  Set P3.0
  Set P3.1
  Select Case Temp
    Case 1:
      Reset P1.0
    Case 2:
      Reset P1.1
    Case 3:
      Reset P1.2
    Case 4:
      Reset P1.3
    Case 5:
      Reset P1.4
    Case 6:
      Reset P1.5
    Case 7:
      Reset P1.6
    Case 8:
      Reset P1.7
    Case 9:
      Reset P3.1
    Case 0:
      Reset P3.0
  End Select
End Sub

Odb_rc5:                                                      'Procedura odbioru kodu RC5
   Command = 255
   Getrc5(subaddress , Command)
   Command = Command And &B10111111
   If Command < 10 And Temp1 <> Command Then
      Temp1 = Command
      New = 1
   End If
Return

Skas_kom:                                                     'Procedura kasowania komunikatu
   Disable Interrupts
   Zezw_kom = 0
   Reset Buzzer
   Set Led_red
   P1 = 255
   Set P3.0
   Set P3.1
   New = 0
   Bitwait S1 , Set
   Waitms 100
   Enable Interrupts
Return