'Wieczny kalendarz z zegarem oraz alarmem
'Marcin Wizania

$large
Config Timer0 = Timer , Gate = Internal , Mode = 1
Declare Sub Zal_l
Declare Sub Inc_mies
Declare Sub Obs_wysw
Declare Sub Mig_c
Declare Sub Sygn

Dim Temp1 As Byte                                             'zmienne tymczasowe
Dim Temp2 As Byte
Dim Temp3 As Byte
Dim Temp4 As Byte
Dim K_wys As Byte                                             'zmienna okreslajaca wlaczony wysw
Dim Wart(10) As Byte                                          'tablica wartosci do wyswietlenia przez wysw
Dim Sek As Byte                                               'sekundy
Dim Minut As Byte                                             'minuty
Dim Godz As Byte                                              'godziny
Dim Stulecia As Byte                                          'stulecia
Dim Lata As Byte                                              'lata
Dim Mies As Byte                                              'miesiace
Dim Dni_t As Byte                                             'dni tygodnia
Dim Dni As Byte                                               'dni
Dim J As Byte                                                 'zmienna licznikowa
Dim Licz As Word                                              'zmienna licznikowa
Dim Al_min As Byte                                            'minuty alarmu
Dim Al_godz As Byte                                           'godziny alarmu
Dim Zm_mig As Byte                                            'okresla ktory wysw miga
Dim Key As Byte                                               'zmienna wcisnietego klawisza
Dim Zezw As Bit                                               'flaga zezw od przerwania do inkr kalendarza
Dim Zez_al As Bit                                             'flaga zezw alarmu
Dim Alarm As Bit                                              'flaga okreslajaca alarm
Dim Beep As Bit                                               'flaga okreslajaca sygnal dzwiekowy
Dim Zez_syg As Bit                                            'flaga zezw sygn dzwiek
Dim R_mies As Bit                                             'flaga wygladu miesiecy

W1 Alias P3.4
W2 Alias P3.3
W3 Alias P3.2
W4 Alias P3.1
W5 Alias P3.0
W6 Alias P1.7
W7 Alias P1.6
W8 Alias P1.5
W9 Alias P1.4
W10 Alias P1.3

On Timer0 Przerw
Enable Interrupts
Enable Timer0
Counter0 = 63750
Start Timer0

P1.2 = 1                                                      'wartosci poczatkowe zmiennych
P1.1 = 1
P1.0 = 1
K_wys = 1
Licz = 0
Sek = 0
Godz = 0
Minut = 0
Dni = 1
Dni_t = 1
Mies = 1
Lata = 0
Stulecia = 20
Zezw = 0
J = 1
Zez_al = 0
Al_godz = 12
Al_min = 0
Zm_mig = 0
Alarm = 0
Beep = 0
Zez_syg = 1
R_mies = 0

Do                                                            'poczatek programu glownego
  If P1.0 = 0 Then                                            'jezeli brak zasilania glownego
    Idle                                                      'to przejdz w stan idle
  Else                                                        'w przeciwnym razie
    If Alarm = 1 Then                                         'jezeli flaga alarm=1 to
      Reset P1.2                                              'sygnalizuj alarm
      Call Sygn
      Waitms 500                                              'jezeli minela minuta alarmu to
      If Minut <> Al_min Then                                 'wylacz alarm
        Alarm = 0
        Set P1.2
      End If
      If Key <> 0 Then                                        'gdy zostal nacisniety ktorys przycisk to kasuj alarm
        Alarm = 0
        Do
          Key = 0
          Call Obs_wysw
          Waitms 20
        Loop Until Key = 0
      End If
    Else                                                      'jezeli flaga alarm=0 to wlacz przypisane funkcje przyciskow
      If Beep = 1 Then                                        'gdy flaga beep ustawiona to
        If Zez_syg = 1 Then                                   'sygnalizuj polowe godziny jednym piskiem
          If Minut = 30 Then                                  'a godziny dwoma piskami
            Reset P1.2
            Call Obs_wysw
            Waitms 100
            Set P1.2
            Zez_syg = 0
          End If
          If Minut = 0 Then
            Call Sygn                                         'procedura dwoch pikniec
            Zez_syg = 0
          End If
        Else                                                  'w przeciwnym razie jezeli minela minuta od sygnalu to ustaw
          If Minut = 31 Or Minut = 1 Then                     'flage zez_syg by byla mozliwa ponowna
            Zez_syg = 1                                       'sygnalizacja
          End If
        End If
      End If

      If Key = 3 Then                                         'jezeli nacisniety S3 to zwieksz zmienna J (J=1 to kalendarz, J=2 to zegar
        Incr J                                                'a J=3 to alarm)
        If J = 4 Then
          J = 1
        End If
        Do                                                    'czekaj w petli na puszczenie przycisku
          Key = 0
          Call Obs_wysw
          Waitms 150
        Loop Until Key = 0
      End If

      If Key = 1 And J = 3 Then                               'nacisniecie przycisku S1 przy wyswietlanym alarmie
        Zez_al = Not Zez_al                                   'powodowac bedzie zezwolenie oraz blokade alarmu
        Do
          Key = 0
          Call Obs_wysw                                       'wywolanie procedury obsl wyswietlacza
          Waitms 150
        Loop Until Key = 0                                    'czekaj na puszecze przycisku
      End If

      If Key = 1 And J = 1 Then                               'nacisniecie przycisku S1 przy wyswietlanym kalendarzu
        R_mies = Not R_mies                                   'powodowac bedzie zmiene trybu wyswietlania miesiecy
        Do
          Key = 0
          Call Obs_wysw                                       'wywolanie procedury obsl wyswietlacza
          Waitms 150
        Loop Until Key = 0                                    'czekaj na puszecze przycisku
      End If

      If Key = 2 And J = 2 Then                               'nacisniecie przycisku S2 przy wysw zegarze
        Zm_mig = 3                                            'wprowadzi w tryb programowania zegara
        Do
          Key = 0                                             'programowana wartosc bedzie migac
          Call Mig_c                                          'poprzez obsluge procedury obs_wysw
          Call Obs_wysw                                       'wywolanie procedury obsl wyswietlacza
        Loop Until Key = 0                                    'czekaj na puszczenie przycisku
        Do
          If Key = 2 Then                                     'przysk S2 bedzie powodowal przejscie do nastepnych
            Incr Zm_mig                                       'ustawianych wartosci poprzez inkrementacje
            If Zm_mig = 7 Then                                'zmiennej zm_mig
              Zm_mig = 0
            End If
            Waitms 200
          End If
          Key = 0
          If Zm_mig = 6 Then                                  '6-te nacisniecie przycisku S2 umozliwi wlaczenie lub wyl
            Wart(3) = Asc( "B")                               'sygnalu dzwiekowego o polowach i pelnych godzinach
            Wart(4) = Asc( "E")
            Wart(5) = Asc( "E")
            Wart(6) = Asc( "P")
            Wart(1) = 0
            Wart(2) = 0
            Wart(9) = 0
            Wart(10) = 0
            If Beep = 1 Then
              Wart(7) = Asc( "O")
              Wart(8) = Asc( "N")
            Else
              Wart(7) = Asc( "O")
              Wart(8) = Asc( "F")
            End If
          Else
            Call Mig_c
            Call Obs_wysw                                     'wywolanie procedury obsl wyswietlacza
          End If
          If Key = 1 Then                                     'podczas migania danej wartosci przysk S1 bedzie inkr dana zmienna
            If Zm_mig = 3 Then
              Incr Godz
              If Godz = 24 Then
                Godz = 0
              End If
            End If
            If Zm_mig = 4 Then
              Incr Minut
              If Minut = 60 Then
                Minut = 0
              End If
            End If
            If Zm_mig = 5 Then
              Sek = 0
            End If
            If Zm_mig = 6 Then
              Beep = Not Beep
              Waitms 100
            End If
          End If
        Loop Until Zm_mig = 0 And Key = 0                     'warunek wyjscia z petli ustawien zegara
      End If

      If Key = 2 And J = 3 Then                               'nacisniecie przycisku S2 przy wyswietlanym alarmie
        Zm_mig = 3                                            'wprowadzi w tryb programowania alarmu
        Do
          Key = 0
          Call Mig_c
          Call Obs_wysw
        Loop Until Key = 0
        Do
          If Key = 2 Then                                     'pozostale instrukcje dzialaja podobnie
            Incr Zm_mig                                       'jak instrukcje ustawien zegara
            If Zm_mig = 5 Then
              Zm_mig = 0
            End If
            Waitms 200
          End If
          Key = 0
          Call Mig_c
          Call Obs_wysw
          If Key = 1 Then
            If Zm_mig = 3 Then
              Incr Al_godz
              If Al_godz = 24 Then
                Al_godz = 0
              End If
            End If
            If Zm_mig = 4 Then
              Incr Al_min
              If Al_min = 60 Then
                Al_min = 0
              End If
            End If
            Waitms 100
          End If
        Loop Until Zm_mig = 0 And Key = 0                     'warunek wyjscia z petli ustawien alarmu
      End If

      If Key = 2 And J = 1 Then                               'nacisniecie przycisku S2 przy wyswietlanym kalendarzu
        Zm_mig = 1                                            'wprowadzi w tryb programowania kalendarza
        Do
          Key = 0
          Call Mig_c
          Call Obs_wysw
        Loop Until Key = 0
        Do
          If Key = 2 Then
            Incr Zm_mig
            If Zm_mig = 6 Then
              Zm_mig = 0
            End If
            Waitms 200
          End If
          Key = 0
          Call Mig_c
          Call Obs_wysw                                       'wywolanie procedury obsl wyswietlacza
          If Key = 1 Then
            If Zm_mig = 1 Then
              Incr Stulecia
              If Stulecia = 100 Then
                Stulecia = 0
              End If
            End If
            If Zm_mig = 2 Then
              Incr Lata                                       'pozostale instrukcje dzialaja podobnie
              If Lata = 100 Then                              'Jak Instrukcje Ustawien Zegara
                Lata = 0
              End If
            End If
            If Zm_mig = 3 Then
              Incr Mies
              If Mies = 13 Then
                Mies = 1
              End If
            End If
            If Zm_mig = 4 Then
              Incr Dni
              If Dni = 32 Then
                Dni = 1
              End If
            End If
            If Zm_mig = 5 Then
              Incr Dni_t
              If Dni_t = 8 Then
                Dni_t = 1
              End If
            End If
            Waitms 100
          End If
        Loop Until Zm_mig = 0 And Key = 0                     'warunek wyjscia z petli ustawien zegara
      End If
    End If
  End If

  If Zezw = 1 Then                                            'kod realizujacy (obliczajaca) wiecznego kalendarza
    Zezw = 0                                                  'flaga zezw zezwala na zwiekszenie dni oraz dni tygodnia
    Incr Dni
    Incr Dni_t
    If Dni_t = 8 Then                                         'jezeli dni_t = 8 to
      Dni_t = 1                                               'przypisz jej wartosc 1
    End If
    If Dni = 29 Then                                          'jezeli dni=29 to
      If Mies = 2 Then                                        'oraz miesiacem jest luty
        Temp4 = Lata Mod 4                                    'to oblicz czy jest to rok zwykly czy przestepny
        If Lata = 0 Then
          Temp4 = Stulecia Mod 4
        End If
        If Temp4 > 0 Then                                     'jesli temp4>0 to rok jest przestepny
          Call Inc_mies                                       'procedura zwiekszenia miesiecy
        End If
      End If
    End If
    If Dni = 30 Then                                          'jesli dni=30
      If Mies = 2 Then                                        'oraz jest luty to
        Call Inc_mies                                         'wywolaj procedure zwiekszenia miesiecy
      End If
    End If
    If Dni = 31 Then                                          'jesli dni=31
      If Mies = 4 Or Mies = 6 Or Mies = 9 Or Mies = 11 Then   'oraz sa miesiace 4 lub 6 lub 9 lub 11 to
        Call Inc_mies                                         'wywolaj procedure zwiekszenia miesiecy
      End If
    End If
    If Dni = 32 Then                                          'jesli dni=32 to
      Call Inc_mies                                           'wywolaj procedure zwiekszenia miesiecy
    End If
  End If                                                      'koniec kodu realizujacego wieczny kalendarz

  Call Obs_wysw                                               'wywolanie procedury obsl wyswietlacza
Loop                                                          'Koniec petli glownej programu
End

Sub Sygn                                                      'procedura obslugi sygnalizatora zpiezo z gener.
  Reset P1.2                                                  'procedura ta wydaje dwa krotkie dzwieki
  Call Obs_wysw                                               'wywolanie procedury obsl wyswietlacza
  Waitms 80
  Set P1.2
  Call Obs_wysw
  Waitms 100
  Reset P1.2
  Call Obs_wysw
  Waitms 80
  Set P1.2
  Call Obs_wysw
End Sub

Sub Mig_c                                                     'procedura realizujaca miganie danego wyswietlacza w zalezmosci
  Waitms 120                                                  'od zmiennej zm_mig
  Select Case Zm_mig
    Case 1:
      Wart(3) = 0
      Wart(4) = 0
    Case 2:
      Wart(5) = 0
      Wart(6) = 0
    Case 3:
      Wart(7) = 0
      Wart(8) = 0
    Case 4:
      Wart(1) = 0
      Wart(2) = 0
    Case 5:
      Wart(9) = 0
      Wart(10) = 0
  End Select
  Waitms 120
End Sub

Sub Obs_wysw                                                  'procedura obslugi wyswietlacza
  If J = 1 Then                                               'dla j=1 wyswietlany jest kalendarz
    Temp3 = Dni / 10                                          'wyciaga ze zmiennej dziesiatki
    Wart(2) = Temp3 + 48                                      'laduje dziesiatki do wyswietlenia
    Temp3 = Dni Mod 10                                        'wyciaga ze zmiennej jednostki
    Wart(1) = Temp3 + 48                                      'laduje jednostki do wyswietlenia
    Temp3 = Stulecia / 10                                     'j.w.
    Wart(3) = Temp3 + 48                                      'j.w.
    Temp3 = Stulecia Mod 10
    Wart(4) = Temp3 + 48
    Temp3 = Lata / 10
    Wart(5) = Temp3 + 48
    Temp3 = Lata Mod 10
    Wart(6) = Temp3 + 48
    If R_mies = 0 Then                                        'gdy r_mies=0 to miesiace arabskie
      Temp3 = Mies / 10
      Wart(7) = Temp3 + 48
      Temp3 = Mies Mod 10
      Wart(8) = Temp3 + 48
    Else
      Select Case Mies                                        'wyswietlenie rzymskich miesiecy
        Case 1:
          Temp2 = 0
          Temp3 = Asc( "1")
        Case 2:
          Temp2 = Asc( "1")
          Temp3 = Asc( "1")
        Case 3:
          Temp2 = 91
          Temp3 = Asc( "1")
        Case 4:
          Temp2 = Asc( "1")
          Temp3 = Asc( "V")
        Case 5:
          Temp2 = 0
          Temp3 = Asc( "V")
        Case 6:
          Temp2 = Asc( "V")
          Temp3 = Asc( "1")
        Case 7:
          Temp2 = Asc( "V")
          Temp3 = 91
        Case 8:
          Temp2 = Asc( "V")
          Temp3 = 92
        Case 9:
          Temp2 = Asc( "1")
          Temp3 = Asc( "X")
        Case 10:
          Temp2 = 0
          Temp3 = Asc( "X")
        Case 11:
          Temp2 = Asc( "X")
          Temp3 = Asc( "1")
        Case 12:
          Temp2 = Asc( "X")
          Temp3 = 91
      End Select
      Wart(7) = Temp2
      Wart(8) = Temp3
    End If
    Select Case Dni_t                                         'wybor slownych dni tyg
      Case 1:
        Temp2 = Asc( "P")                                     'zapisanie kodu ascii litery do zmiennej tymczasowej
        Temp3 = Asc( "O")
      Case 2:
        Temp2 = Asc( "W")
        Temp3 = Asc( "T")
      Case 3:
        Temp2 = Asc( "S")
        Temp3 = Asc( "R")
      Case 4:
        Temp2 = Asc( "C")
        Temp3 = Asc( "Z")
      Case 5:
        Temp2 = Asc( "P")
        Temp3 = Asc( "I")
      Case 6:
        Temp2 = Asc( "S")
        Temp3 = Asc( "O")
      Case 7:
        Temp2 = Asc( "N")
        Temp3 = Asc( "I")
    End Select
    Wart(10) = Temp2                                          'zapis zmiennych tymczasowych do zmiennej tablicy wyswietlacza
    Wart(9) = Temp3
  End If

  If J = 2 Then                                               'dla j=2 wyswietlany jest zegar
    Temp3 = Minut / 10                                        'kod podobny do kodu wyswietlajacego kalendarz
    Wart(2) = Temp3 + 48
    Temp3 = Minut Mod 10
    Wart(1) = Temp3 + 48
    Wart(3) = Asc( "T")
    Wart(4) = Asc( "I")
    Wart(5) = Asc( "M")
    Wart(6) = Asc( "E")
    Temp3 = Godz / 10
    Wart(7) = Temp3 + 48
    Temp3 = Godz Mod 10
    Wart(8) = Temp3 + 48
    Temp3 = Sek / 10
    Wart(10) = Temp3 + 48
    Temp3 = Sek Mod 10
    Wart(9) = Temp3 + 48
  End If

  If J = 3 Then                                               'dla j=3 wyswietlany jest alarm
    Temp3 = Al_min / 10
    Wart(2) = Temp3 + 48                                      'kod podobny do kodu wyswietlajacego kalendarz
    Temp3 = Al_min Mod 10
    Wart(1) = Temp3 + 48
    Wart(3) = 0
    Wart(4) = Asc( "A")
    Wart(5) = Asc( "L")
    Wart(6) = 0
    Temp3 = Al_godz / 10
    Wart(7) = Temp3 + 48
    Temp3 = Al_godz Mod 10
    Wart(8) = Temp3 + 48
    If Zez_al = 1 Then
      Wart(10) = Asc( "O")
      Wart(9) = Asc( "N")
    Else
      Wart(10) = Asc( "O")
      Wart(9) = Asc( "F")
    End If
  End If
End Sub

Sub Inc_mies                                                  'Procedura zwiekszenia miesiecy
  Dni = 1                                                     'dni=1
  Incr Mies                                                   'zwieksz miesiace
  If Mies = 13 Then                                           'jezeli mies=13 to
    Mies = 1                                                  'przypisz mies wartosc 1
    Incr Lata                                                 'zwieksz lata
    If Lata = 100 Then                                        'jesli lata=100 to
      Lata = 0                                                'wyzeruj lata oraz
      Incr Stulecia                                           'zwieksz stulecia
    End If
  End If
End Sub

Sub Zal_l                                                     'Procedura ladujaca wartosci wyswietlane do rejestrow przesownych U1 oraz U2
  Temp1 = Wart(k_wys)
  Temp2 = Lookup(temp1 , Zn1)                                 'pobranie pierszego bajta z tablicy kodow zn1
  Shiftout P3.7 , P3.5 , Temp2 , 1                            'zaladowanie pierwszego bajta danych
  Temp2 = Lookup(temp1 , Zn2)                                 'pobranie drugiego bajta z tablicy kodow zn2
  Shiftout P3.7 , P3.5 , Temp2 , 1                            'zaladowanie drugiego bajta danych
End Sub

Przerw:                                                       'Przerwanie od timer0 wywolywane co 2ms (obsluga wyswietlacza oraz zegara)
  Counter0 = 63750                                            'wartosc poczatkowa licznika
  Start Timer0
  Incr Licz                                                   'zwieksz zmienna licznikowa
  If Licz = 500 Then                                          'gdy zmienna licz=500 to odliczona zostala 1 sekunda
    Licz = 0                                                  'zeruj zmienna licz
    Incr Sek                                                  'zwieksz sek
    If Sek = 60 Then                                          'gdy sek=60 to
      Sek = 0                                                 'zeruj sek
      Incr Minut                                              'zwieksz minuty
      If Minut = 60 Then                                      'gdy minuty=60
        Minut = 0                                             'to Zeruj Minuty
        Incr Godz                                             'zwieksz godziny
        If Godz = 24 Then                                     'gdy godz=24 to
          Godz = 0                                            'zeruj godz
          Zezw = 1                                            'ustaw flage zezw1 ktora zezwoli na zwiekszenie wartosci kalendarza
        End If
      End If
    End If
  End If
  P3 = P3 Or &B00111111                                       'wylaczenie wyswietlaczy
  P1 = P1 Or &B11111000                                       'wylaczenie wyswietlaczy
  If P1.0 = 1 Then                                            'gdy jest zasilanie glowne to steruj wyswietlaczem
    Call Zal_l                                                'procedura ladowania danych do rejestrow
    Select Case K_wys                                         'w zaleznosci od zmiennej k_wys obsluguj dany wyswietlacz
      Case 1 : Reset W1
      Case 2 : Reset W2
      Case 3 : Reset W3
      Case 4 : Reset W4
      Case 5 : Reset W5
      Case 6 : Reset W6
      Case 7 : Reset W7
      Case 8 : Reset W8
      Case 9 : Reset W9
      Case 10 : Reset W10
    End Select
    If Zez_al = 1 Then                                        'gdy flaga zez_al=1 to sprawdzaj kryterium zaistnienia alarmu
      If Godz = Al_godz Then                                  'gdy godz=al_godz oraz
        If Minut = Al_min Then                                'gdy minut=al_min oraz
          If Sek = 0 Then                                     'sek=0 to
            Alarm = 1                                         'ustaw flage wlaczenia alarmu
          End If
        End If
      End If
    End If
    If K_wys < 4 Then                                         'gdy obslugiwany jest wyswietlacz 1..3 oraz gdy
      If P1.1 = 1 Then                                        'nacisniety jest przycisk S1...S3
        Key = K_wys                                           'to zapisz do zmiennej key kod nacisnietego klawisza
      End If
    End If
    Incr K_wys                                                'zwieksz zmienna k_wys
    If K_wys = 11 Then                                        'gdy k_wys=11 to
      K_wys = 1                                               'zapisz do zmiennej k_wys wartosc 1
    End If
  End If
Return                                                        'powrot z przerwania

Zn1:                                                          'tablica danych dla rejestru U1
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255,
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255,
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 237 , 119,
Data 119 , 119 , 119 , 119 , 255 , 119 , 119 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 119 , 229 , 255,
Data 237 , 127 , 127 , 247 , 119 , 237 , 237 , 91 , 255 , 250 , 222 , 255 , 119 , 223 , 87 , 119 , 237
Data 255 , 187 , 159 , 154 , 234 , 187 , 255 , 237

Zn2:                                                          'tablica danych dla rejestru U2
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255,
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255,
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 0 , 255 , 136,
Data 192 , 115 , 68 , 4 , 240 , 0 , 64 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 48 , 192 , 12
Data 192 , 12 , 60 , 4 , 51 , 204 , 156 , 63 , 15 , 51 , 51 , 0 , 56 , 0 , 56 , 68 , 252 , 3 , 63 , 51 , 255 , 255 , 204 , 51 , 51